//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "Unit1.h"
#include "dll_def_tp.h"
#include "Konstanten.h"
#include "malloc.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

// prototypes
TForm1 *Form1;

BITMAPINFO *myBMP;
BITMAPINFO* bitmapinfo_w;
void* pBildAdr;

HINSTANCE vorHandle; // Hinstance definiert eine Variable fr Handles

// Loads the Library and gets the function pointer with GetProcAddress
bool __fastcall InitDLL(void)
{
  vorHandle=LoadLibrary("Gr4CDLL.DLL") ;
  if((int) vorHandle<=HINSTANCE_ERROR)
  {
   MessageBox(0,"Fehler","Gr4cdll.DLL nicht gefunden",MB_OK+MB_ICONSTOP);
   Application->Terminate();
   return (false);
  }
  else
  {
   // get function pointer to DLL functions
   tp_Get_Error= (unsigned short (PASCAL *)()) GetProcAddress(vorHandle,"Get_Error");
   tp_GetVersionNumber= (unsigned short (PASCAL *)()) GetProcAddress(vorHandle,"GetVersionNumber");
   tp_Set_BW= (void (PASCAL *)(int,int)) GetProcAddress(vorHandle,"Set_BW");
   tp_Max_Device_Number = (unsigned short(PASCAL *)()) GetProcAddress(vorHandle,"Max_Device_Number");
   tp_Initialize=(void (PASCAL *)(int))  GetProcAddress(vorHandle,"Initialize") ;
   tp_Set_Color_System=(void (PASCAL *)(int,int))  GetProcAddress(vorHandle,"Set_Color_System")  ;
   tp_Set_Brightness=(void (PASCAL *)(int,short))  GetProcAddress(vorHandle,"Set_Brightness")  ;
   tp_Set_Contrast=(void (PASCAL *)(int,int))  GetProcAddress(vorHandle,"Set_Contrast")  ;
   tp_Set_Saturation=(void (PASCAL *)(int,int,int))  GetProcAddress(vorHandle,"Set_Saturation")  ;
   tp_Set_Hue=(void (PASCAL *)(int,short))  GetProcAddress(vorHandle,"Set_Hue")  ;
   tp_Get_Brightness=(unsigned short (PASCAL *)(int))  GetProcAddress(vorHandle,"Get_Brightness")  ;
   tp_Get_Contrast=(unsigned short (PASCAL *)(int))  GetProcAddress(vorHandle,"Get_Contrast")  ;
   tp_Get_Sat_U=(unsigned short (PASCAL *)(int))  GetProcAddress(vorHandle,"Get_Sat_U")  ;
   tp_Get_Sat_V=(unsigned short (PASCAL *)(int))  GetProcAddress(vorHandle,"Get_Sat_V")  ;
   tp_Get_Hue=(unsigned short (PASCAL *)(int))  GetProcAddress(vorHandle,"Get_Hue")  ;
   tp_Set_S_Video=(void (PASCAL *)(int))  GetProcAddress(vorHandle,"Set_S_Video")  ;
   tp_Set_S_VideoEx=(void (PASCAL *)(int,char))  GetProcAddress(vorHandle,"Set_S_VideoEx")  ;     // nicht nach procadress_i=0 fragen, da bei altem Treiber immer 0
   tp_Set_Composite=(void (PASCAL *)(int))  GetProcAddress(vorHandle,"Set_Composite")  ;
   tp_Set_LDec=(void (PASCAL *)(int,int,int))  GetProcAddress(vorHandle,"Set_LDec")  ;
   tp_Set_Channel=(void (PASCAL *)(int,int))  GetProcAddress(vorHandle,"Set_Channel")  ;
   tp_Set_ChannelEx=(void (PASCAL *)(int,int))  GetProcAddress(vorHandle,"Set_ChannelEx")  ;
   tp_Set_Interlace=(void (PASCAL *)(int,int))  GetProcAddress(vorHandle,"Set_Interlace")  ;
   tp_Set_AGC=(void (PASCAL *)(int,int,int,int))  GetProcAddress(vorHandle,"Set_AGC")  ;
   tp_Set_ColorBars=(void (PASCAL *)(int,int))  GetProcAddress(vorHandle,"Set_ColorBars")  ;
   tp_Set_CKill=(void (PASCAL *)(int,int))  GetProcAddress(vorHandle,"Set_CKill")  ;
   tp_TemporalDect=(void (PASCAL *)(int,int,int,int))  GetProcAddress(vorHandle,"TemporalDect")  ;
   tp_LumaControl=(void (PASCAL *)(int,int,int))  GetProcAddress(vorHandle,"LumaControl")  ;
   tp_Set_Image=(void (PASCAL *)(int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int,int))  GetProcAddress(vorHandle,"Set_Image")  ;
   tp_Start_Grabber=(void (PASCAL *)(int))GetProcAddress(vorHandle,"Start_Grabber")  ;
   tp_Stop_Grabber=(void (PASCAL *)(int)) GetProcAddress(vorHandle,"Stop_Grabber")  ;
   tp_Data_Present=(unsigned short (PASCAL *)(int))  GetProcAddress(vorHandle,"Data_Present")  ;
   tp_GetPictureBufferAddress=(unsigned long (PASCAL *)(int,long))  GetProcAddress(vorHandle,"GetPictureBufferAddress")  ;
   // long ersetzt durch unsigned long *
   tp_Get_Signal_Status=(unsigned short (PASCAL *)(int)) GetProcAddress(vorHandle,"Get_Signal_Status")  ;
   tp_Get_Video_Status=(unsigned short (PASCAL *)(int))  GetProcAddress(vorHandle,"Get_Video_Status")  ;
   tp_Set_GPIO_Direction=(void (PASCAL *)(int,int))  GetProcAddress(vorHandle,"Set_GPIO_Direction")  ;
   tp_Set_GPIO_Data=(void (PASCAL *)(int,int))  GetProcAddress(vorHandle,"Set_GPIO_Data")  ;
   tp_Get_GPIO_Data=(unsigned short (PASCAL *)(int))  GetProcAddress(vorHandle,"Get_GPIO_Data")  ;
  }
  if(tp_Get_Error==0 || tp_GetVersionNumber==0 ||  tp_Set_BW==0 ||
     tp_Max_Device_Number==0 ||  tp_Initialize==0 || tp_Set_Color_System==0 ||
     tp_Set_Brightness==0 ||  tp_Set_Contrast==0 ||  tp_Set_Saturation==0 ||
     tp_Set_Hue==0 || tp_Get_Brightness==0 || tp_Get_Contrast==0 ||
     tp_Get_Sat_U==0 ||  tp_Get_Sat_V==0 ||  /*tp_Get_Hue==0 || */ tp_Set_S_Video==0 ||
     //tp_Set_S_VideoEx==0 ||
     tp_Set_Composite==0 ||  tp_Set_LDec==0 ||  tp_Set_Channel==0 ||
     //tp_Set_ChannelEx==0 ||
     tp_Set_Interlace==0 || tp_Set_AGC==0 ||  tp_Set_ColorBars==0 || tp_Set_CKill==0 ||
     tp_TemporalDect==0 ||  tp_LumaControl==0 ||  tp_Set_Image==0 ||  tp_Start_Grabber==0 ||
     tp_Stop_Grabber==0 ||  tp_Data_Present==0 ||  tp_GetPictureBufferAddress==0 ||
     tp_Get_Signal_Status==0 || tp_Get_Video_Status==0 ||  tp_Set_GPIO_Direction==0 ||
     tp_Set_GPIO_Data==0 ||  tp_Get_GPIO_Data==0)
  {
   MessageBox(0,"Fehler","Fehler beim Einbinden der Grabberfunktionen",MB_OK+MB_ICONSTOP);
   Application->Terminate();
   FreeLibrary(vorHandle);
   return (false);
  }
 return (true);
}

// allocate a bitmap structure for use with StretchDIBits
BITMAPINFO* __fastcall bitmapinfo(unsigned short x_i,unsigned short y_i)
{
  bitmapinfo_w=(BITMAPINFO*)malloc(sizeof(BITMAPINFOHEADER));
  BITMAPINFOHEADER *bitmapinfoheader_w=(BITMAPINFOHEADER*)bitmapinfo_w;
  bitmapinfoheader_w->biSize=sizeof(BITMAPINFOHEADER);
  bitmapinfoheader_w->biWidth=x_i;
  bitmapinfoheader_w->biHeight=y_i;
  bitmapinfoheader_w->biPlanes=1;
  bitmapinfoheader_w->biBitCount=24;
  bitmapinfoheader_w->biCompression=BI_RGB;
  bitmapinfoheader_w->biSizeImage=0;
  bitmapinfoheader_w->biXPelsPerMeter=0;
  bitmapinfoheader_w->biYPelsPerMeter=0;
  bitmapinfoheader_w->biClrUsed=0;
  bitmapinfoheader_w->biClrImportant=0;
 return(bitmapinfo_w);
}

//---------------------------------------------------------------------------
// OnIdle handler will update the LiveImage every time the application is idle
void __fastcall TForm1::MyIdleHandler(TObject *Sender, bool &Done)
{
    static unsigned short GrabbSignal = 2;

    unsigned short Dp = 3;
    HDC myDC = GetDC(Form1->Handle);

    do {
        Dp = tp_Data_Present(1);
        Sleep(5);
    } while ((Dp & 0x03) != GrabbSignal);

    if (GrabbSignal == 3)
        GrabbSignal = 0;
    else
        GrabbSignal = 3;


    // paint grabber buffer to form
    StretchDIBits(myDC,
                  0,0,720, 576,
                  0,0, 720, 576,
                  pBildAdr,
                  myBMP,
                  DIB_RGB_COLORS,
                  SRCCOPY);

    ReleaseDC(Form1, myDC);
    Done = false;                  // we want to be called again
}


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
    Application->OnIdle = MyIdleHandler;  // install our idle handler
    InitDLL();                            // load dll and get function pointer
    tp_Initialize(1);                     // initialze grabber
    tp_Set_Color_System(1, Pal);          // set to PAL
    tp_Set_ChannelEx(1, 1);
    tp_Set_Composite(1);
    // set the image parameters. In this demo we are using a fixed
    // resolution with 320x200 pixels
    tp_Set_Image(1, 0, 0, 720, 288, 720, 288, RGB24, 0, 0, 720, 288, 720, 288, RGB24, Pal, 1, 0);
    if (tp_Get_Error())
        MessageBox(0, "InitError", "Fehler bei der Initialisierung", MB_OK);

    myBMP = bitmapinfo(720,576);     // allocate bitmap
    // get address of Buffer
    pBildAdr =(void*)tp_GetPictureBufferAddress(1,720*576*3); // get adress of picture
    // start grabber
    tp_Start_Grabber(1);
}
//---------------------------------------------------------------------------


